<?php 
/**
 * READ THE README! That's where all the answers to all your questions are!
 *
 * Released under a Creative Commons License: Attribution, Share Alike
 * -- {{http://creativecommons.org/licenses/by-sa/3.0/us/}}
 * 
 * I'm EdB {{http://wonderwinds.com/}} and I approve this message
 *
 * @package plugins
 * @subpackage Comment Tags
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * @package plugins
 * @subpackage Comment Tags
 */
class commenttags_plugin extends Plugin
{
	var $author = 'EdB';
	var $author_url = 'http://wonderwinds.com/';
	var $code = 'commenttags';
	var $group = 'comments';
	var $help_url = 'http://1912webworks.com/plugins.php';
	var $number_of_installs = 1;
	var $priority = 98;
	var $version = '0.1';


	/**
	 * @see Plugin::PluginInit()
	 */
	function PluginInit( & $params )
	{
		$this->long_desc = $this->T_('This plugin will display a toolbar with buttons to quickly insert safely allowable HTML tags around selected text in a comment.');
		$this->name = $this->T_('Comment Tags');
		$this->short_desc = $this->T_('Some buttons for commenters to use common HTML.');
	}


	/**
	 * @see Plugin::GetDefaultSettings()
	 */
	function GetDefaultSettings( & $params )
	{
		$default_settings = array(
			'allow_links' => array(
				'label' => $this->T_('Allow links'),
				'id' => $this->classname.'allow_links',
				'type' => 'checkbox',
				'defaultvalue' => '0',
				'note' => $this->T_('Read the readme for what file to edit before enabling links.'),
			),
		);

	return $default_settings;
	}


	/**
	 * @see Plugin::TemplateBeginHtmlHead()
	 */
	function TemplateBeginHtmlHead()
	{
		require_css($this->get_plugin_url().'commenttags.css', true, NULL, 'screen' );
		require_js( 'functions.js' );
	}


	/**
	 * @see Plugin::DisplayCommentToolbar()
	 */
	function DisplayCommentToolbar( & $params )
	{
		echo '<script type="text/javascript">'."\n";
		echo '//<![CDATA['."\n";
		echo 'var CommentTags = new Array();'."\n";
		echo 'var CommentLinks = new Array();'."\n";
		echo 'var CommentOpenTags = new Array();'."\n";
		echo 'function CommentButton(id, display, tagStyle, tagStart, tagEnd, tit, open) {'."\n";
		echo 'this.id = id;'."\n";
		echo 'this.display = display;'."\n";
		echo 'this.tagStyle = tagStyle;'."\n";
		echo 'this.tagStart = tagStart;'."\n";
		echo 'this.tagEnd = tagEnd;'."\n";
		echo 'this.tit = tit;'."\n";
		echo 'this.open = open;'."\n";
		echo '}'."\n";
		$start_butt = 'CommentTags[CommentTags.length] = new CommentButton( ';
		$end_butt = ' );'."\n";
		echo $start_butt."'Comment_del', 'del', 'text-decoration:line-through;', '<del>', '</del>', 'delete (line-through)'".$end_butt;
		echo $start_butt."'Comment_strong', 'str', 'font-weight:bold;', '<strong>', '</strong>', 'strong (bold)'".$end_butt;
		echo $start_butt."'Comment_em', 'em', 'font-style:italic;', '<em>', '</em>', 'emphasis (italics)'".$end_butt;
		echo $start_butt."'Comment_block', 'quote', 'margin-left:6px;', '<blockquote>', '</blockquote>', 'blockquote'".$end_butt;
		if( $this->Settings->get( 'allow_links' ) )
		{
			echo $start_butt."'Comment_link', 'link', 'text-decoration:underline;margin-left:6px;', '', '</a>', 'a href'".$end_butt;
		}
		echo $start_butt."'Comment_red', 'red', 'margin-left:6px;color:red;', '<span class=\"ctr\">', '</span>', 'red text'".$end_butt;
		echo $start_butt."'Comment_gre', 'green', 'color:green;', '<span class=\"ctg\">', '</span>', 'green text'".$end_butt;
		echo $start_butt."'Comment_blu', 'blue', 'color:blue;', '<span class=\"ctb\">', '</span>', 'blue text'".$end_butt;
		?>
		function CommentShowButton(button, i) {
			if( button.id == 'Comment_link' ) {
				document.write('<input type="button" id="' + button.id + '" title="' + button.tit + '" style="' + button.tagStyle + '" class="quicktags" onclick="CommentInsertLink(app_Canvas, ' + i + ');" value="' + button.display + '" />');
				} else { // Normal buttons:
				document.write('<input type="button" id="' + button.id + '" title="' + button.tit + '" style="' + button.tagStyle + '" class="quicktags" onclick="CommentInsertTag(app_Canvas, ' + i + ');" value="' + button.display + '"  />');
				}
			}
		function CommentAddTag(button) {
			if( CommentTags[button].tagEnd != '' ) {
				CommentOpenTags[CommentOpenTags.length] = button;
				document.getElementById(CommentTags[button].id).value = '/' + document.getElementById(CommentTags[button].id).value;
				}
			}
		function CommentRemoveTag(button) {
			for (i = 0; i < CommentOpenTags.length; i++) {
				if (CommentOpenTags[i] == button) {
					CommentOpenTags.splice(i, 1);
					document.getElementById(CommentTags[button].id).value = document.getElementById(CommentTags[button].id).value.replace('/', '');
					}
				}
			}
		function CommentCheckOpenTags(button) {
			var tag = 0;
			for (i = 0; i < CommentOpenTags.length; i++) {
				if (CommentOpenTags[i] == button) {
					tag++;
					}
				}
			if (tag > 0) {
				return true;
				} else {
				return false;
				}
			}
		function CommentCloseAllTags() {
			var count = CommentOpenTags.length;
			for (o = 0; o < count; o++) {
				CommentInsertTag(app_Canvas, CommentOpenTags[CommentOpenTags.length - 1]);
				}
			}
		function CommentToolbar() {
			document.write('<div>');
			for (var i = 0; i < CommentTags.length; i++) {
				CommentShowButton(CommentTags[i], i);
				}
			document.write('<input type="button" id="Comment_close" style="margin-left:8px;" class="quicktags" onclick="CommentCloseAllTags();" title="<?php echo $this->T_('Close all tags') ?>" value="X" />');
			document.write('</div>');
			}
		function CommentInsertTag( myField, i ) {
			var sel_text = b2evo_Callbacks.trigger_callback("get_selected_text_for_"+myField.id);
			var focus_when_finished = false; // used for IE
			if( sel_text == null ) { // detect selection:
				if(document.selection) {
					myField.focus();
					var sel = document.selection.createRange();
					sel_text = sel.text;
					focus_when_finished = true;
					}
				else if(myField.selectionStart || myField.selectionStart == '0') {
					var startPos = myField.selectionStart;
					var endPos = myField.selectionEnd;
					sel_text = (startPos != endPos);
					}
				}
			if( sel_text ) {
				// some text selected
				textarea_wrap_selection( myField, CommentTags[i].tagStart, CommentTags[i].tagEnd, 0 );
				} else {
				if( !CommentCheckOpenTags(i) || CommentTags[i].tagEnd == '') {
					textarea_wrap_selection( myField, CommentTags[i].tagStart, '', 0 );
					CommentAddTag(i);
					} else {
					textarea_wrap_selection( myField, '', CommentTags[i].tagEnd, 0 );
					CommentRemoveTag(i);
					}
				}
			if(focus_when_finished) {
				myField.focus();
				}
			}
		function CommentInsertLink(myField, i, defaultValue) {
			if (!defaultValue) {
				defaultValue = 'http://';
				}
			if (!CommentCheckOpenTags(i)) {
				var URL = prompt( '<?php echo $this->T_('URL') ?>:', defaultValue);
				if (URL) {
					CommentTags[i].tagStart = '<a href="' + URL + '">';
					CommentInsertTag(myField, i);
					}
				} else {
				CommentInsertTag( myField, i );
				}
			}
		//]]>
		</script>

		<div class="edit_toolbar">
		<script type="text/javascript">CommentToolbar();</script>
		<noscript>If you enable javascript you will get a groovy little toolbar thet lets you spruce up your comment ;)</noscript>
		</div>

		<?php
		return true;
	}

	/**
	 * @see Plugin::AdminDisplayCommentToolbar()
	 */
	function AdminDisplayCommentToolbar( & $params )
	{
		$this->DisplayCommentToolbar( $params );
	}


}

?>
