<?php
/**
 * This file implements the Admin UI class.
 *
 * DO NOT EDIT THIS FILE!!!
 * In order to provide multiple admin styles, this file must be kept intact.
 * If you change it you run the risk of breaking some admin features.  To
 * make a customized admin interface, copy any admin template folder to a
 * new name then edit ONLY the style.css file.
 *
 * This file is part of the Quam Plures project - {@link http://quamplures.net/}.
 * See also {@link https://launchpad.net/quam-plures}.
 *
 * @copyright (c) 2009 - 2011 by the Quam Plures developers - {@link http://quamplures.net/}
 * @copyright (c)2003-2009 by Francois PLANQUE - {@link http://fplanque.net/}.
 * Parts of this file are copyright (c)2005 by Daniel HAHLER - {@link http://thequod.de/contact}.
 *
 * @license http://quamplures.net/license.html GNU General Public License (GPL)
 *
 * {@internal Open Source relicensing agreement:
 * Daniel HAHLER grants Francois PLANQUE the right to license
 * Daniel HAHLER's contributions to this file and the b2evolution project
 * under any OSI approved OSS license (http://www.opensource.org/licenses/).
 * }}
 *
 * {@internal Below is a list of authors who have contributed to design/coding of this file: }}
 * @author blueyed: Daniel HAHLER
 *
 * @package admin
 */
if( !defined('QP_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * Includes
 */
require_once dirname(__FILE__).'/../_adminUI_general.class.php';


/**
 * We define a special template for the main menu.
 *
 * @package pond
 */
class AdminUI extends AdminUI_general
{
	/**
	 * This function should init the templates - like adding Javascript through the {@link add_headline()} method.
	 */
	function init_templates()
	{
		// This is included before controller specifc require_css() calls:
		global $admin_template;
		require_css( 'qp_view_admin/'.$admin_template.'/style.css', true );
	}


	/**
	 * GLOBAL HEADER - APP TITLE, LOGOUT, ETC.
	 *
	 * @return string
	 */
	function get_page_head()
	{ // Display MAIN menu:
		$r = '<div id="header">'.$this->get_html_menu().'</div>';
		return $r;
	}


	/**
	 *
	 *
	 * @return string
	 */
	function get_body_top()
	{
		global $Messages, $mode;

		$r = '<div class="wrapper">';
		if( empty($mode) )
		{
			$r .= $this->get_page_head();
		}
		$r .= $this->get_bloglist_buttons();
		$r .= '<div class="panelbody">'."\n\n";
		// Display info & error messages
		$r .= $Messages->display( NULL, NULL, false, 'all', NULL, NULL, 'action_messages' );
		return $r;
	}


	/**
	 * Get the end of the HTML <body>. Close open divs, etc...
	 *
	 * @return string
	 */
	function get_body_bottom()
	{
		return "\n</div>\n</div>\n";
	}


	/**
	 * Get the footer text
	 */
	function get_footer_contents()
	{
		global $app_footer_text, $copyright_text, $app_name, $app_homepage;
		global $rsc_url;
		global $Hit;

		$r = '<div class="footer">';
		if( $Hit->is_winIE() )
		{
			$r .= '<!--[if lt IE 7]>
<div style="text-align:center; color:#f00; font-weight:bold;">'
.T_('WARNING: Internet Explorer 6 may not able to display this admin template properly. We strongly recommend you upgrade to IE 7 or Firefox.')
.'</div><![endif]-->';
		}
		$r .= '<a href="'.$app_homepage.'" class="footer_logo">';
		$r .= '<img src="'.$rsc_url.'img/adminfooter-logo.png" alt="Powered by '.$app_name.'" width="142" height="43" longdesc="'.$app_homepage.'" /></a>';
		$r .= '<div class="copyright">';
		$r .= $app_footer_text.'<br />'.$copyright_text."</div></div>\n\n";
		return $r;
	}

}

?>
